﻿using System.Data;
using System.Drawing;

using DevExpress.XtraEditors;
using DevExpress.XtraMap;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 빙맵 키
        /// </summary>
        private string bingKey = "INPUT YOUR BING KEY";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 빙 맵 데이터 공급자를 설정한다.

            this.bingMapDataProvider.BingKey = this.bingKey;

            #endregion
            #region 데이터 테이블을 설정한다.

            DataSet dataSet = new DataSet();

            dataSet.ReadXml("DATA\\sochi2014.xml");

            DataTable table = dataSet.Tables[0];

            #endregion
            #region 파이 차트 데이터 어댑터를 설정한다.

            PieChartDataAdapter pieChartDataAdapter = new PieChartDataAdapter();

            pieChartDataAdapter.Mappings.Latitude   = "CapitalLat";
            pieChartDataAdapter.Mappings.Longitude  = "CapitalLon";
            pieChartDataAdapter.Mappings.PieSegment = "MedalClass";
            pieChartDataAdapter.Mappings.Value      = "Quantity";
            pieChartDataAdapter.PieItemDataMember   = "Name";
            pieChartDataAdapter.ItemMinSize         = 20;
            pieChartDataAdapter.ItemMaxSize         = 60;
            pieChartDataAdapter.DataSource          = table;

            pieChartDataAdapter.MeasureRules = new MeasureRules();

            pieChartDataAdapter.MeasureRules.RangeStops.Add(1 );
            pieChartDataAdapter.MeasureRules.RangeStops.Add(10);
            pieChartDataAdapter.MeasureRules.RangeStops.Add(20);
            pieChartDataAdapter.MeasureRules.RangeStops.Add(30);
            pieChartDataAdapter.MeasureRules.RangeStops.Add(40);

            #endregion
            #region 키 색상 색상화기를 설정한다.

            KeyColorColorizer keyColorColorizer = new KeyColorColorizer();

            keyColorColorizer.ItemKeyProvider = new ArgumentItemKeyProvider();

            keyColorColorizer.Colors.Add(Color.FromArgb(255, 207, 98 ));
            keyColorColorizer.Colors.Add(Color.FromArgb(169, 181, 188));
            keyColorColorizer.Colors.Add(Color.FromArgb(233, 152, 118));

            keyColorColorizer.Keys.Add(new ColorizerKeyItem() { Key = 1, Name = "Gold"   });
            keyColorColorizer.Keys.Add(new ColorizerKeyItem() { Key = 2, Name = "Silver" });
            keyColorColorizer.Keys.Add(new ColorizerKeyItem() { Key = 3, Name = "Bronze" });

            #endregion
            #region 벡터 항목 레이어를 설정한다.

            this.vectorItemsLayer.Data      = pieChartDataAdapter;
            this.vectorItemsLayer.Colorizer = keyColorColorizer;

            #endregion
        }

        #endregion
    }
}